# OpenDiachronicMaps
Odm est un projet inspiré de osm appliqué a l'étude cartographique diachronique. l' objectif est de permettre aux contributeurs volontaires d'ajouter, de georeferencer, de nettoyer, de vectoriser des cartographies anciennes a lechelle de la france et d'assembler ce processus de traitement en plusieurs cartographies cohérentes offrant une vue et une comprehension à l'echelle de l'ensemble et de chacunes de ses parties. Cet assemblage et ces ressouces ainsi que leur modifications sont ensuite rendu accessibles et coordonnées aux plus grand nombre en fonction des capacités de chacun par l'intermediaire d'une plateforme permettant d'integrer les ressources de ce patromoine à des outils de traitement geomatique et un travail collaboratif de l'etude historique du territoire, et ce de maniere compatible et complementaire avec les travaux de recherches "professionnelles" des organismes comme Alpage ou l'IGN.

## fonctionnement

concretement, il s'agit d'une plateforme de webmapping chargeant des tuiles de differents jeux de feuillets (ou de donnée vectorielles) ajoutés et traités par les utilisateurs afin de generer une carte selon les reglages de fourchette de temps et de nature des feuillets ou données affiché.
De la il est possible de telecharger l'ensemble de ces donnée dans un seul fichier assemblé par la plateforme dans la zone choisie. il est alors possible de l'exploiter pour un projet independant ou bien  de le traiter dans un logiciel tier avant d'integrer les modifications dans la base de ODM. À terme certaines modifications devraient etre accessibles directement sur la plateforme pour s'adresser au plus grand nombre.

## principe de grille d'avancement
chaque jeux est ajouté ou complété selon differentes etapes d'avancement definies et normés par la plateforme.
Chaque jeux de feuillets issu typiquement d'une campagne de cartographie datant de l'epoque concernée est ajouté a la plateforme et associé a une commune actuelle, une commune ancienne et eventuellent un lieu-dit. Une base est créée par l'utilisateur qui renseigne les données suivantes (localisation, date, auteur de la carte, feuillets ou carte entière, sources... Si une base similaire existe dejà, l'utilisateur en est informé et il lui est permis le cas echeant de combler les manques grace a un apercue dans la carte de ce qui existe déjà.

À titre indicatif, les etapes d'avancement pourrait etre:
### raster:
- scan et ajout d'un jeu à une base unique par campagne carthographique1
- nettoyage/homogenisation graphique
- geolocalisation2 
- rognage des superpositions3 

### Vecteur:
- tracé filaire des routes et caracterisation.
- tracé des ilots
- tracé des parcelles.
- tracé des espaces publics
- tracé des bâtiment
4

1 il serai necessaire de pouvoire relier les bases dune meme campagne sur l'emprise de chaque ville a une base "meta" reliant les sous bases dune meme campagne couvrant plusieurs villes. 

2 il serai necessaire de pouvoir réaliser la géolocalisation avant le traitement graphique car c'est une etape plus accessible et satisfaisante. Les fichiers raster geolocalisé sont classiquement de type geoTIFF ou jpeg20000(jp2). le geotiff est lourd et la geolocalisation est ecrasé par
photoshop lors des traitement graphique. ( experience personnelle + voir https://georezo.net/forum/viewtopic.php?id=3240)
il serai egalement necessaire de pouvoir conserver la liste des points et l'algorithme de deformation
utilisé. une maniere simple est de demander a lutilisateur de fournir le fichier .points creee par QGIS lors de cette operation et de renseigner la projection.

3 cette operation pourrait se faire manuellement coté utilisateur avec la production d'un png de meme dimension que le geoTIFF ou bien automatiquement coté serveur a partir des tracés des routes ( premiere etape de vectorisation )

4 une liste de calques non-vide doit etre presente pour qu'un fichier dxf soit accepté. 

## fonctionnalités du projet:
- gestion de l'affichage de la carte assemblée. ( ajout et reglages des calques raster et vectoriels sur leaflet )
- gestion de la creation de base unique par campagne carthographique et par ville. 
- affichage du gestionaire d'états  d'avancement global d'un jeu et feuillet par feuillet.
- selection a l'échelle/detection de la zone spatiotemporelle de travail et generation des données disponibles et de leur etat d'avancement.
- selection des données à telecharger et generation de fichiers d'assemblage en jpg, dxf, qgz.
- gestion d'un systeme de controle qualité par les pairs par l'intermediaire d'une grille de notation (qualité de l'assemblage des tuiles, qualité de la superposition avec l'existant actuel); ceci permettant de n'afficher que les jeux ayant l'avancement mais aussi une qualité egale ou supperieur au choix de l'utilisateur.
- creation, partage et notation de prereglages des calques de la carte afin de selectionner les plus populaires/meilleures aux yeux de la communauté. Enregistrement des reglages utilisateur dabord par fichier config sur son ordinateur puis par hebergement sur le site via un compte utilisateur.
- gestion des comptes utilisateurs ( necessaire pour pouvoir editer les cartes) l'ajout anonyme est possible mais l'IP est surveillé pour reperer les frequences de commit anormales. 
- optimisation des performances d'affichages: generation journaliere de fichier image basse resolution assemblage couvrant une grande zone pour l'affichage de carte tres dezoomée. Ces meta-tuile sont generées pour les principaux preset ( les mieux notés) Cf tuiles pyramidales.
- integration et generation de flux wms.
- plusieurs onglets pourraient etres proposés avec differents services connexes et services simplifiés destiné aux utilisateurs moins chevronnés. Onglet de quests/jeux faisant avancer l'avancement des cartes.

## etapes de developpement
plop

### integration de leaflett:
- ajout dune carte leaflet
- charger des images dans leaflet
- echelle de visibilitée/chargement dans la rame.
- systeme de calques et reglage d'affichages( transparence, couleurs...)
- extraire l'emprise de la vue actuelle
- charger un flux wms/wmts
- creation d'un panneau de reglage avec des boutons et des sliders.
- interpreter un lien wms-getcapabilities et proposer des boutons en consequences.

### creation de bases uniques
(dabors avec une donnée "campagne globale" puis avec metabase si necessaire.)
- definition des caracteristiques principales d'une base.
- affichage de l'avancement dune base.
- detection de base similaire (plus avancée: date) ou déjà existante.
### projections:
leaflet peut-il gerer plusieurs projections:
https://kartena.github.io/Proj4Leaflet/
### geolocalisation
- integrer une image geolocalisé dans leaflet
- integrer plusieurs images sans lagg?
- detecter l'emprise d'une image geolocalisé et afficher un fichier plus simple (jpg)?
- integrer un outil de geolocalisation dans la plateforme.
### données vectoriellee
- chargement d'un calque dans leaflet
- verifiaction et ajout dans la base de donnée
- generation de fichier.
### traitement d'image
- filtrer bandes de couleurs
- images similaires dans une même  base. 
### environnement 
- impact de la taille de la fenetre
- utilisateur flateforme 
### optimisation de l'affichage 
- generation de mega tuile pour les echelle dezoomé. cf tuile pyramidalee


